function G15Bar_Command(cmd) G15BarConfigFrame:Show(); end

function G15BarConfig_OnLoad()
    this:RegisterEvent("VARIABLES_LOADED");
    SLASH_G15BAR1 = "/g15bar";
	SlashCmdList["G15BAR"] = G15Bar_Command;
end

function G15BarConfig_NumBars(num)
	if(num == 0) then
		M1Bar:Hide();
		M2Bar:Hide();
		M3Bar:Hide();
	elseif(num == 1) then
		M1Bar:Show();
		M2Bar:Hide();
		M3Bar:Hide();
	elseif(num == 2) then
		M1Bar:Show();
		M2Bar:Show();
		M3Bar:Hide();
	elseif(num == 3) then
		M1Bar:Show();
		M2Bar:Show();
		M3Bar:Show();
	end
	G15Bar2Config["NumBars"] = num;
end


function G15BarConfig_Labels(n)
	if(n) then
		M1GrabBar:Show();
		M2GrabBar:Show();
		M3GrabBar:Show();
	else
		M1GrabBar:Hide();
		M2GrabBar:Hide();
		M3GrabBar:Hide();
	end
	G15Bar2Config["Labels"] = n;
end

function G15BarConfig_Lock(n)
    G15Bar2Config["Lock"] = n;
end

function G15BarConfig_Reset()
	G15BarConfig_Bound(true);
	G15BarConfig_Lock(false);
	G15BarConfig_Labels(true);
	G15BarConfig_NumBars(3);
	G15BarConfig_Scale(1);
    M1GrabBar:ClearAllPoints();
	M1GrabBar:SetPoint("CENTER","UIParent","CENTER",0,0);
	G15BarConfigFrame:Hide();
end

function G15BarConfig_Bound(input)
	if (input) then
		M2BarButton1:ClearAllPoints();
		M3BarButton1:ClearAllPoints();
		M2BarButton2:ClearAllPoints();
		M3BarButton2:ClearAllPoints();
	    M3GrabBar:ClearAllPoints();
	    M2GrabBar:ClearAllPoints();
		M2BarButton2:SetPoint("LEFT", M2BarButton1, "RIGHT", 3, 0);
		M3BarButton2:SetPoint("LEFT", M3BarButton1, "RIGHT", 3, 0);
	    M2BarButton1:SetPoint("LEFT", M1BarButton3, "RIGHT", 12, 0);
	    M3BarButton1:SetPoint("LEFT", M2BarButton3, "RIGHT", 12, 0);
	    M2GrabBar:SetPoint("BOTTOM", M2BarButton2, "TOP", 0, 9);
		M3GrabBar:SetPoint("BOTTOM", M3BarButton2, "TOP", 0, 9);
    else
		M2BarButton1:ClearAllPoints();
		M3BarButton1:ClearAllPoints();
		M2BarButton2:ClearAllPoints();
		M3BarButton2:ClearAllPoints();
        M3GrabBar:ClearAllPoints();
        M2GrabBar:ClearAllPoints();
		M2BarButton2:SetPoint("TOP", M2GrabBar, "BOTTOM", 0, -9);
		M3BarButton2:SetPoint("TOP", M3GrabBar, "BOTTOM", 0, -9);
        M2BarButton1:SetPoint("RIGHT", M2BarButton2, "LEFT", -3, 0);
        M3BarButton1:SetPoint("RIGHT", M3BarButton2, "LEFT", -3, 0);
	end
	G15Bar2Config["Bound"] = input;
end

function G15BarConfig_Scale(input)
	G15Bar:SetScale(input);
	G15Bar2Config["Scale"] = input;	
end

function G15BarConfig_OnEvent()
 	if (not G15Bar2Config) then G15Bar2Config = {}; G15BarConfig_Reset(); end
 	if (G15Bar2Config["NumBars"]) then G15BarConfig_NumBars(G15Bar2Config["NumBars"]); end
 	if (G15Bar2Config["Labels"]) then G15BarConfig_Labels(G15Bar2Config["Labels"]); end
 	if (G15Bar2Config["Bound"]) then G15BarConfig_Bound(G15Bar2Config["Bound"]); end
 	if (G15Bar2Config["Scale"]) then G15BarConfig_Scale(G15Bar2Config["Scale"]); end
end

function G15BarConfig_Bind()
	mods = {"SHIFT", "CTRL", "ALT"};
	keys = {"Q", "W", "E",
			"A", "S", "D",
			"R", "T", "Y",
			"F", "G", "H",
			"U", "I", "O",
			"J", "k", "L"};
   
    for i,m in ipairs(mods) do
        for j,k in ipairs(keys) do
        	local bind = m.."-"..k;
        	SetBinding(bind, nil);
			SetBindingClick(bind, "M"..i.."BarButton"..j);
    	end
    end
    SaveBindings(2);
end                    